#include <endian.h>
#include "project.h"

WGS84 paf_lookup(Places place, char *qpostcode)
{
  BOSXY xy = { 0 };
  BOSGRID g;
  WGS84 wgs = { 0 };
  off_t o, lo;
  unsigned char r[30], lr[30];
  char buf[1024];
  char postcode[80];
  FILE *f;
  u_int32_t i;

  i = 0;

  while (qpostcode[i]) {
    postcode[i] = toupper(qpostcode[i]);
    postcode[i + 1] = 0;
    i++;
  }


  sprintf(buf, "%s/PAF_packed_index", getenv("PAFPATH"));
  f = fopen(buf, "r");
  if (!f)
    return wgs;

  bzero(r, 4);
  bzero(lr, 4);
  lo = 0;

  while (fgets(buf, sizeof(buf) - 1, f)) {
    bcopy(buf, r, 3);
    o = atoi(buf + 4);

    if ((strncmp(postcode, lr, 3) >= 0) && (strncmp(postcode, r, 3) < 0))
      break;

    bcopy(r, lr, 3);
    lo = o;
  }


  fclose(f);


  lo *= 16;


  sprintf(buf, "%s/PAF_packed", getenv("PAFPATH"));
  f = fopen(buf, "r");
  if (!f)
    return wgs;
  fseek(f, lo, SEEK_SET);
  bzero(lr, 16);
  bzero(r, 16);
  while (fread(r, 16, 1, f) == 1) {
    if ((strcmp(postcode, lr) >= 0) && (strcmp(postcode, r) < 0))
      break;
    bcopy(r, lr, 16);
  }

  fclose(f);

  bcopy(r + 8, &i, 4);
  xy.x = ntohl(i) * 10;
  bcopy(r + 12, &i, 4);
  xy.y = ntohl(i) * 10;

  if (strcmp(postcode, lr)) {
    printf("Nearest match %s at (%d,%d)\n", lr, xy.x, xy.y);
  } else {
    printf("Exact match %s at (%d,%d)\n", lr, xy.x, xy.y);
  }

  g = bosxy_to_bosgrid(xy);
  wgs = bosgrid_to_wgs84(g);

  return wgs;
}
